<?php

class SortableDataObject extends DataObjectDecorator
{
	
	static $sortable_classes = array();
	static $sorting_permission = "ADMIN";
	static $sortable = false;
	
	public static function add_sortable_class($className)
	{
		DataObject::add_extension($className,'SortableDataObject');
	}
	
	public static function add_sortable_classes(array $classes)
	{
		foreach($classes as $class)
			self::add_sortable_class($class);
	}
	
	public static function remove_sortable_class($class)
	{
		Object::remove_extension($class, 'SortableDataObject');
	}
	
	public function extraStatics()
	{
		return array (
			'db' => array (
				'SortOrder' => 'Int'
			)
		);
	}	

	public static function set_sorting_permission($perm)
	{
		self::$sorting_permission = $perm;
	}
	
	public static function sorting_permission()
	{
		return self::$sorting_permission;
	}
	
	private function openSortableTag($tag)
	{
		return "<{$tag} id='item_{$this->owner->ID}' class='move'>";
	}
		
	public function LI()
	{
		return $this->openSortableTag('li');
	}
	
	public function _LI()
	{
		return "</li>";
	}
	
	public function DIV()
	{
		return $this->openSortableTag('div');
	}
	
	public function _DIV()
	{
		return "</div>";
	}
	

}

?>